#include <stdio.h>
#include <avs/flow.h>
#include <avs/avs_data.h>
#include <avs/field.h>
#include <time.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/timeb.h>

fin()
{
	int out_port;		/* temporary to hold the port number */
	int parm;		/* temporary to hold the parm number */

	/* Set the module name and type */
	AVSset_module_name("bench", MODULE_DATA);

	/* There are no input ports for this module */

	/* Create output ports for the result */
	out_port = AVScreate_output_port("Field Output", "field 1D scalar uniform float");

	/* Add parameter:  */
	parm = AVSadd_parameter("Read Stock Data Browser", "string", 0, 0, 0);
	AVSconnect_widget(parm,"browser");
	/* Add parameter:  */
	parm = AVSadd_parameter("Read Model Parameter Browser", "string", 0, 0, 0);
	AVSconnect_widget(parm,"browser");

	/* Add parameter:  */
	parm = AVSadd_parameter("points/frame","integer", 30, 1, 100);
	AVSconnect_widget(parm,"idial");

	/* Add parameter: an enable/disable toggle for the scope */
	parm = AVSadd_parameter("sleep", "boolean", 1, 0, 1);
	parm = AVSadd_parameter("step", "oneshot", 1, 0, 1);

	/* There is no compute function for this module */
}

#define PERFRAME 30

main(argc,argv)
int	argc;
char	*argv[];
{
   int fin();
   int sleep,step;
   float *v_b, *psi, *rho;
   char *StockFileName, *ParameterFileName;
   AVSfield_float *output, *input;
   
   int dims[1];
   int i,j, size = PERFRAME;
   float *tmp,temp;
   float ran();
   
   FILE *sfp, *pfp;
   int flag;
   float sz,szdiv,k,rate,t,tdiv,div,call, vt_a, vt_b;
   long int total;
   
   long int vtime;
   clock_t vtime1,vtime2,clock();
     int gettimeofday();
 
   struct timeval *tp,stp;
   struct timezone *tzp,stzp;
   long int stime1,stime2,utime1,utime2,utime,stime;

   tp = &stp; tzp = &stzp;
  
   /* coroutine initilization */
   AVScorout_init(argc,argv,fin);
   AVScorout_set_sync(0); 

   while (1) {
     StockFileName = ParameterFileName = NULL;
     total = 0;
     sleep = step = 1;
     input = NULL;
     AVSparameter_visible("Read Stock Data Browser",1);
     AVSparameter_visible("Read Model Parameter Browser",1);
     AVSparameter_visible("points/frame",1);
     do {
       AVScorout_wait();  
       AVScorout_input(&StockFileName, &ParameterFileName, &size,&sleep,&step);
     } while (!StockFileName || !ParameterFileName);
     
     AVSparameter_visible("Read Stock Data Browser",0);
     AVSparameter_visible("Read Model Parameter Browser",0);
     AVSparameter_visible("points/frame",0);

     /* Allocate space for graph data */
     dims[0] = size;
     input = (AVSfield_float *)AVSdata_alloc("field 1D scalar uniform float",dims);
     
     i = 0;
     flag = 1;
     /* first output an initial graph */
       
     for (i=0; i<=(size-1); i++) {
       input->data[i] = 10.*ran(i*100.0)+i/8. ;  /* 1st vector element */
     };
     output = input;

     gettimeofday(tp, tzp)  ;
     printf("Start s1 = %ld s2=%ld \n",tp->tv_sec,tp->tv_usec);

     while (1) {
       
       if (sleep) AVScorout_wait();
       AVScorout_input(&StockFileName, &ParameterFileName, &size,&sleep,&step);
       AVScorout_exec(); 
    
       gettimeofday(tp, tzp)  ;
       stime2 = tp->tv_sec;  utime2 = tp->tv_usec; 
       stime = stime2 - stime1; utime = utime2 - utime1;
	 printf("Time =%ld microsecond\n",1000000*stime+utime);


/*       vtime2 = clock();
       vtime = (vtime2 - vtime1)/1000;
       printf("vstart=%ld vend= %ld Graph-time = %ld milliseconds\n",vtime1,
	 vtime2,vtime);
       vtime1 = clock(); */
      
       gettimeofday(tp, tzp)  ;
       stime1 = tp->tv_sec;  utime1 = tp->tv_usec;    
 
       AVScorout_output(output);  
     }
   }
 }

  float ran(n)
  float n;
  { 
    double drand48();
  return(n*drand48());
  }

